from Survey import Survey

class Quiz(Survey):
	"""A Curriculum Document holds both instructional material and, optionally,
	brief unit tests to see whether students understood the instruction."""
	archetype_name = meta_type = portal_type = 'Quiz'

	actions = (
		{
		'id'		  : 'view',
		'name'		  : 'View',
		'action'	  : 'string:${folder_url}/survey_view',
		'permissions' : (VIEW_CONTENT_PERMISSION,),
		'visible'     : 0
		},
		{
		'id'		  : 'edit',
		'name'		: 'Edit',
		'action'	  : 'string:${folder_url}/base_edit',
		'permissions' : (EDIT_CONTENT_PERMISSION,)
		},
		{
		'id'		  : 'questions',
		'name'		: 'Questions',
		'action'	  : 'string:${folder_url}/survey_questions',
		'permissions' : (EDIT_CONTENT_PERMISSION,)
		},
		{
		'id'		  : 'results',
		'name'		: 'Results',
		'action'	  : 'string:${folder_url}/survey_results',
		'permissions' : (VIEW_RESULTS,)
		},
		{
		'id'		  : 'take',
		'name'		: 'Take Survey',
		'action'	  : 'string:${folder_url}/survey_take',
		'permissions' : (TAKE_SURVEY,)
		}

registerType(Quiz)
